$(function()
{
    setTimeout(changeType, 50);
});

window.changeType = function ()
{
    const type = $('[name=type]').val();
    if(typeof type === 'undefined') return;
    if(type == 'spug')
    {
        $('#app').removeClass('hidden');
        $('#env').find('.form-label').addClass('required');
        $('[name=host]').closest('.form-group').find('.form-label').addClass('required');
        $('[name^=products]').closest('.form-group').find('.form-label').addClass('required');

        $('[name^=host]').zui('picker').render({items: [], multiple: true});
        $('[name=app]').zui('picker').render({items: []});
        $('[name=env]').zui('picker').render({items: []});
    }
    else
    {
        $('#app').addClass('hidden');
        $('#env').find('.form-label').removeClass('required');
        $('[name=host]').closest('.form-group').find('.form-label').removeClass('required');
        $('[name^=products]').closest('.form-group').find('.form-label').removeClass('required');

        if(typeof(deploy) == 'undefined')
        {
            $('[name^=host]').zui('picker').$.clear();
            $('[name=env]').zui('picker').$.clear();
        }
        $('[name=releaseTPL]').val(0);
        $('[name=app]').zui('picker').$.clear();

        $('[name^=host]').zui('picker').render({items: JSON.parse(hosts), multiple: false});
        $('[name=env]').zui('picker').render({items: JSON.parse(envs)});
    }

    initApp();
};

window.initApp = function ()
{
    const type = $('[name=type]').val();
    if(typeof type === 'undefined' || type != 'spug') return;

    toggleLoading('#app', true);
    const $picker = $('[name=app]').zui('picker');
    $picker.$.clear();

    $.getJSON($.createLink('deploy', 'ajaxGetSpugApps'), function(items)
    {
        $picker.render({items: items});
        if(typeof(deploy) != 'undefined') $picker.$.setValue(deploy.app);
        toggleLoading('#app', false);
    });
};

window.changeApp = function ()
{
    const type = $('[name=type]').val();
    if(typeof type === 'undefined' || type != 'spug') return;

    toggleLoading('#env', true);
    const $picker = $('[name=env]').zui('picker');
    $picker.$.clear();

    const app = $('[name=app]').val();

    $.getJSON($.createLink('deploy', 'ajaxGetEnvByApp', 'appID=' + app), function(items)
    {
        $picker.render({items: items});
        if(typeof(deploy) != 'undefined') $picker.$.setValue(deploy.env);
        toggleLoading('#env', false);
    });
};

window.changeEnv = function ()
{
    const type = $('[name=type]').val();
    if(typeof type === 'undefined' || type != 'spug') return;

    const hostPicker = $('[name^=host]').zui('picker');
    hostPicker.$.clear();
    hostPicker.render({items: []});

    const app       = $('[name=app]').val();
    const env       = $('[name=env]').val();
    const envPicker = $('[name=env]').zui('picker');
    if(envPicker.length == 0 || !env) return;

    let releaseTPL = 0;
    let host       = '';
    envPicker.options.items.forEach(function(item)
    {
        if(item.value == env)
        {
            releaseTPL = item.releaseTPL;
            host       = item.host;
        }
    });

    if(typeof(host) !== 'undefined') toggleLoading('#host', true);
    $('[name=releaseTPL]').val(releaseTPL);

    $.getJSON($.createLink('deploy', 'ajaxGetHostList', 'hostIdList=' + host), function(items)
    {
        hostPicker.render({items: items});
        if(typeof(deploy) != 'undefined') hostPicker.$.setValue(deploy.host);
        toggleLoading('#host', false);
    });
};
