<?php
namespace zin;

global $lang;

$envList = data('envList');
$hosts   = data('hosts');
$hasFlow = data('hasFlow');
$deploy  = data('deploy');

$hostsJS = array();
$envJS   = array();
if(!empty($hosts)) foreach($hosts as $hostID => $host) $hostsJS[] = array('value' => $hostID, 'text' => $host);
if(!empty($envList)) foreach($envList as $envID => $env) $envJS[] = array('value' => $envID, 'text' => $env);
jsVar('hosts', json_encode($hostsJS));
jsVar('envs', json_encode($envJS));
jsVar('deploy', $deploy);

query('#name')->before
(
    formGroup
    (
        set::width('1/2'),
        set::label($lang->deploy->type),
        set::name('type'),
        set::items($lang->deploy->typeList),
        set::disabled(true),
        set::required(true),
        set::value($deploy->type)
    )
);

query('#owner')->after
(
    formGroup
    (
        setID('app'),
        setClass('hidden'),
        set::width('1/2'),
        set::label($lang->deploy->app),
        set::name('app'),
        set::required(true),
        set::items(array()),
        on::change()->call('changeApp')
    ),
    formGroup
    (
        setID('env'),
        set::width('1/2'),
        set::label($lang->deploy->env),
        set::name('env'),
        set::items($envList),
        $deploy->type != 'spug' ? set::value($deploy->env) : null,
        on::change()->call('changeEnv')
    ),
    formHidden('releaseTPL', $deploy->releaseTPL)
);

jsVar('deployID', $deploy->id);
if($hasFlow)
{
    query('#desc')->before
    (
        formGroup
        (
            set::label($lang->deploy->reviewer),
            div(setID('reviewerBox'))
        )
    );
    pageJS(<<<JAVASCRIPT
    $(function()
    {
        var link = $.createLink('deploy', 'ajaxGetNodes', 'deployID=' + deployID);
        loadCurrentPage({url: link, selector: '#reviewerBox', partial: true});
    });
JAVASCRIPT
    );
}
